#!/usr/bin/env node

// register coffee-script so that we can use it in other files
require('coffee-script/register')

var path = require('path');

var program = require('commander');

var util = require('../lib/util');
var config = require('../lib/config');

var root = path.dirname(__dirname),
    version;

try {
    version = require(path.join(root, 'package.json')).version;
} catch (e) {
    version = '0.0.1';
}
// load configuration before doing anything
config.load()

program
    .version(version)
    .option('-v, --verbose', 'display verbose output', false)
    .usage('<command> [options]');

util.walkSync(path.join(root, 'lib', 'commands'), ['.coffee'], function (file, folder) {
    var command = require(file);

    command(program);
});

program.parse(process.argv);

if (process.argv.length < 3) {
    process.stdout.write(program.helpInformation());
}

// write the changes to the configuration on exit
process.on('exit', function () {
    config.write();
});
