request = require 'request'
colors = require 'colors'
config = require('../config.coffee').data
path = require 'path'
zlib = require 'zlib'
tar = require 'tar'
fs = require 'fs'
os = require 'os'
wrench = require 'wrench'
semver = require 'semver'

uncompress = (folder, cb)  ->
    unzip = zlib.createGunzip()
    unzip.pipe(tar.Extract({
        type: 'Directory',
        path: folder
    })).on 'end', cb

    return unzip


module.exports = register = (program) ->
    program
        .command 'install [component]'
        .description 'install component that match name'
        .action installComponent

fetchDependencies = (dependecyJson) ->
    cexJson = JSON.parse fs.readFileSync dependecyJson
    if cexJson.dependencies
        console.log "fetching dependecies for #{cexJson.name.cyan}"
        for component, version of cexJson.dependencies
            staisfaiedVersion = version
            componentJsonFile = path.join process.cwd(), config.component_dir, component, config.jsonFileName
            if fs.existsSync componentJsonFile
                depCexJson = JSON.parse fs.readFileSync  componentJsonFile
                if semver.satisfies depCexJson.version, version
                    console.log "component  #{component.cyan} exists and it satisfies #{dependecyJson.cyan} requirements for version #{version.cyan} "
                    continue
                else
                    console.warn "Cannot resolve version for component #{component.cyan}\nCurrently installed is #{depCexJson.version.cyan} but for #{cexJson.name.cyan} is required #{version.cyan}"
                    staisfaiedVersion = semver.maxSatisfying depCexJson.version, version
                    console.warn "Will be resolve to #{staisfaiedVersion.cyan}"

            installComponent "#{component}##{staisfaiedVersion}"

installComponent = (pattern, options) ->
    if not pattern and pattern.length
        componentJsonFile = path.join process.cwd(), config.jsonFileName
        if fs.existsSync componentJsonFile
            return fetchDependencies componentJsonFile
        console.log 'missing cex.json file'
        return
    [name,version] = pattern.split('#',2)
    version= version || '*'
    packageUrl = config.paths.install.replace('[name]',
        encodeURIComponent(name)).replace('[version]',
        encodeURIComponent(version))

    request packageUrl , (error, response, body) ->
        if not error and response.statusCode  == 200
            pkg = JSON.parse body
            console.log  "installing #{pkg.name.cyan.bold}##{version}"
            packageDir =  path.resolve(process.cwd(), config.component_dir, pkg.name)
            tmpPath = path.join os.tmpDir(), (pkg.name + '-' + pkg.version)

            if fs.existsSync packageDir
                wrench.rmdirSyncRecursive packageDir
            wrench.mkdirSyncRecursive packageDir

            request(pkg.dist.tarball).pipe uncompress tmpPath, ->
                wrench.copyDirSyncRecursive path.join(tmpPath, 'package'), packageDir,
                    forceDelete: true
                    excludeHiddenUnix: true
                fetchDependencies  path.join packageDir, config.jsonFileName
                console.log "installed #{name.cyan} successful"

                wrench.rmdirSyncRecursive tmpPath

        else
            console.log "faild component with name #{pattern.cyan} not found."
            request config.paths.search.replace('[name]', pattern), (error, response, body) ->
                if not error and response.statusCode  == 200
                    packs = JSON.parse body
                    if packs.length
                        console.log "did you meant:"
                        for pkg in packs
                            console.log pack.name.cyan.bold
