request = require 'request'
colors = require 'colors'
semver = require 'semver'

config = require('../config.coffee').data

module.exports = register = (program) ->
    program
        .command 'search [pattern]'
        .description 'List all components that match a certain pattern'
        .action listComponents


listComponents = (pattern, options) ->
    request config.paths.search, (error, response, body) ->
        if not error and response.statusCode  == 200
            pkgs = JSON.parse body
            for key, pkg of pkgs
                if key is '_updated'
                    continue

                if !pattern or pkg.name.indexOf(pattern) isnt -1
                    version = semver.maxSatisfying Object.keys(pkg.versions), '*'
                    console.log pkg.name.cyan.bold, version.blue.bold, pkg.description || ''
        else
            console.log 'no module matches your pattern', (pattern || '').cyan
