fs = require 'fs'
path = require 'path'

_ = require 'lodash'

defaultConfig = require '../config'
util = require './util'

homeDir = process.env.HOME || process.env.USERPROFILE
configPath = path.join homeDir, '.cexrc'

transforms =
    _auth:
        get: (value) -> JSON.parse(new Buffer(value, 'base64').toString('utf8'))
        set: (value) ->
            if typeof value is 'object'
                value = JSON.stringify(value)
            buffer = new Buffer(value).toString('base64')

            return buffer

module.exports =
    data: {}
    load: ->
        _.extend(@data, _.cloneDeep(defaultConfig))
        if fs.existsSync configPath
            userConfig = JSON.parse(fs.readFileSync(configPath))

            for key, value of userConfig
                if transforms.hasOwnProperty(key) and value
                    userConfig[key] = transforms[key].get(value)

            _.extend(@data, userConfig)

        try
            projectConfigPath = util.getProjectConfig process.cwd()

            projectConfig = JSON.parse fs.readFileSync projectConfigPath

            _.extend @data, projectConfig
        catch e
            return

    write: ->
        configDiff = util.extractDiff defaultConfig, @data

        for key, value of configDiff
            if transforms.hasOwnProperty(key) and value
                configDiff[key] = transforms[key].set(value)

        fs.writeFileSync configPath, JSON.stringify(configDiff, undefined, 4)
