'use strict'

fs = require 'fs'
path = require 'path'
util = require 'util'

util.walkSync = (folder, extensions, callback) ->
    if arguments.length < 2
        return

    if typeof extensions is 'function'
        callback = extensions
        extensions = []

    walk = (folder) ->
        try
            files = fs.readdirSync folder
        catch e
            return # ignore errors

        for file in files
            file = path.join folder, file

            try
                stat = fs.statSync file
            catch e
                return # ignore errors

            if stat.isDirectory()
                walk file
            else if extensions.length is 0 or extensions.indexOf path.extname(file) isnt -1
                callback file, folder

    walk folder

util.extractDiff = (obj1, obj2) ->
    diffs = {}
    for key, value of obj1
        if typeof(value) == 'object' and typeof(obj2[key] ) == 'object'
            if Object.keys(tempdif = util.extractDiff value, obj2[key]).length
                diffs[key] = tempdif
        else if value != obj2[key] and obj2.hasOwnProperty(key)
            diffs[key] = obj2[key]
    return diffs

util.getProjectConfig = (cwd) ->
    configFileName = '.cexrc'
    cwd = path.resolve cwd
    homeDir = process.env.HOME || process.env.USERPROFILE

    while homeDir isnt cwd
        unless fs.existsSync path.join cwd, configFileName
            cwd = path.dirname cwd
            continue

        return path.join cwd, configFileName

    throw new Error "The specified path is not a CEX project"

module.exports = util
